//=============================================================================
// file: AbstractBrush.h
// desc: 
//		 defines the abstract base class that serves as a direct ancestor for
//		 all brush classes.  See DotBrush.[h,cpp] for an example of a brush
//		 derived from this class.
//=============================================================================

#ifndef __ABSTRACT_BRUSH_HEADER__
#define __ABSTRACT_BRUSH_HEADER__

#include "impressionist.h"

//==========[ class AbstractBrush ]============================================

class AbstractBrush {

public:

	//---[ Brush Drawing Methods ]-------------------------

		// called to start a brush stroke, size is the size of the brush, c is
		// the color of the brush and target is its location in the window
	virtual void brushBegin( int size, Color c, Point target ) = 0;
		// called repeatedly during a brush stroke
	virtual void brushMove( int size, Color c, Point target ) = 0;
		// called to end a brush stroke
	virtual void brushEnd( int size, Color c, Point target ) = 0;
};

#endif